HDU 5137 How Many Maos Does the Guanxi Worth <迪杰斯特拉算法变形>

来源:互联网 发布:淘宝香帝缘 编辑:程序博客网 时间:2024/05/01 21:30

How Many Maos Does the Guanxi Worth

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 512000/512000 K (Java/Others)
Total Submission(s): 1029    Accepted Submission(s): 351


Problem Description
"Guanxi" is a very important word in Chinese. It kind of means "relationship" or "contact". Guanxi can be based on friendship, but also can be built on money. So Chinese often say "I don't have one mao (0.1 RMB) guanxi with you." or "The guanxi between them is naked money guanxi." It is said that the Chinese society is a guanxi society, so you can see guanxi plays a very important role in many things.

Here is an example. In many cities in China, the government prohibit the middle school entrance examinations in order to relief studying burden of primary school students. Because there is no clear and strict standard of entrance, someone may make their children enter good middle schools through guanxis. Boss Liu wants to send his kid to a middle school by guanxi this year. So he find out his guanxi net. Boss Liu's guanxi net consists of N people including Boss Liu and the schoolmaster. In this net, two persons who has a guanxi between them can help each other. Because Boss Liu is a big money(In Chinese English, A "big money" means one who has a lot of money) and has little friends, his guanxi net is a naked money guanxi net -- it means that if there is a guanxi between A and B and A helps B, A must get paid. Through his guanxi net, Boss Liu may ask A to help him, then A may ask B for help, and then B may ask C for help ...... If the request finally reaches the schoolmaster, Boss Liu's kid will be accepted by the middle school. Of course, all helpers including the schoolmaster are paid by Boss Liu.

You hate Boss Liu and you want to undermine Boss Liu's plan. All you can do is to persuade ONE person in Boss Liu's guanxi net to reject any request. This person can be any one, but can't be Boss Liu or the schoolmaster. If you can't make Boss Liu fail, you want Boss Liu to spend as much money as possible. You should figure out that after you have done your best, how much at least must Boss Liu spend to get what he wants. Please note that if you do nothing, Boss Liu will definitely succeed.
 

Input
There are several test cases.

For each test case:

The first line contains two integers N and M. N means that there are N people in Boss Liu's guanxi net. They are numbered from 1 to N. Boss Liu is No. 1 and the schoolmaster is No. N. M means that there are M guanxis in Boss Liu's guanxi net. (3 <=N <= 30, 3 <= M <= 1000)

Then M lines follow. Each line contains three integers A, B and C, meaning that there is a guanxi between A and B, and if A asks B or B asks A for help, the helper will be paid C RMB by Boss Liu.

The input ends with N = 0 and M = 0.

It's guaranteed that Boss Liu's request can reach the schoolmaster if you do not try to undermine his plan.
 

Output
For each test case, output the minimum money Boss Liu has to spend after you have done your best. If Boss Liu will fail to send his kid to the middle school, print "Inf" instead.
 

Sample Input
4 51 2 31 3 71 4 502 3 43 4 23 21 2 302 3 100 0
 

Sample Output
50Inf
 

Source
2014ACM/ICPC亚洲区广州站-重现赛(感谢华工和北大)
 
题意:
 
         首先输入两个数,第一个数n代表有多少个人,第二个数m代表有多少个关系,第一个是老板,第n个是校长,老板想找关系让他的儿子来这个学校上学,所以要通过层层的关系网来找到校长,在找关系的过程中需要花钱,找到校长后也需要掏钱去贿赂,然后输入m行代表关系还有需要的钱,由于有一个人在中间捣鬼,不让老板实现它的目的,所以在这个关系网中除了1号和n号其他的人都有可能不帮老板刘,让你求出在这些情况下老板刘需要付的(每一种情况)最小的钱中的(所有的情况中)最多的钱!
 
思路:
 
          先用迪杰斯特拉的方法算出去掉中间的点(以及和这一点之间所有的关系)之后的最短的距离,然后求这些距离中的最大值!
 
代码:
 
#include <stdio.h>#include <string.h>#include <algorithm>#define INF 0x3f3f3f3fusing namespace std;int n,m;int map[50][50];int d[50][50];int dis[50];int vis[50];void init()//初始化! {memset(map,INF,sizeof(map));    int a,b,c;for(int j=1;j<=m;j++){scanf("%d%d%d",&a,&b,&c);if(map[a][b]>c)map[a][b]=map[b][a]=c;}}void dijkstra(int x)//求最短路! {    for(int j=1;j<=n;j++){   dis[j]=map[x][j];}dis[x]=0;vis[x]=1;int min,k;for(int i=0;i<n;i++){min=INF;for(int j=1;j<=n;j++){if(!vis[j]&&dis[j]<min){min=dis[j];k=j;}}if(min==INF)break;vis[k]=1;for(int j=1;j<=n;j++){if(!vis[j]&&dis[j]>dis[k]+map[k][j])dis[j]=dis[k]+map[k][j];}}}int main(){while(scanf("%d%d",&n,&m)&&(n||m)){init();int min=0;for(int i=2;i<=n-1;i++)//将可能阻断的地方全部都尝试一下,然后找出所有的最短路中的最大值! {memset(vis,0,sizeof(vis));//将不帮忙的那个人直接放进集合里面,就不用更新其他的点与起点之间的距离了 vis[i]=1;//也就是其他的点就不会经过它走到起点,然后求1-n的最短的路径就行了! dijkstra(1);min=min>dis[n]?min:dis[n];//最短路中的最长路即为所求! }if(min==INF)//如果最短路中的最长路为INF,则说明不能够到达终点,输出INF! printf("Inf\n");else//否则输出最短路中的最长路!     printf("%d\n",min);}return 0;}

 
 
0 0